#	Manuel Noriega : "Edit User" for UserGroups
#		((requires the UserGroups Addon))
#	by plushpuffin@wwddfd.com
#	http://www.wwddfd.com
#

push(@Addons_Loaded, 'Manuel Noriega 1.0');
$Addons_List{'Manuel Noriega 1.0'} = ['npa_noriega.pl', 'Basic User Information'];
push(@Addons_PageHandler, 'Noriega_PageHandler');
push(@Addons_NPHTMLFoot, 'Noriega_HTMLFoot');
push(@Addons_NPHTMLHead_Head, 'Noriega_NPHTMLHead_Head');

push(@Addons_UGEditUser, q~NoriegaUGEdit~);
$uField{'NUI'} = q~Noriega User Info Hook~;
$ugSaveUser{'NUI'} = q~NoriegaUGSave~;
$uMinEditLevel{'NUI'} = 1;

sub NoriegaUGEdit {
	$_ = time;
	print qq~<tr><td>Change Password or leave blank:</td><td><input type="hidden" name="NUI" value="$_"><input type="text" name="pword" size="40" value=""></td></tr>
	<tr><td>Email Address:</td><td><input type="text" name="email" size="40" value="$Email{$ug}"></td></tr>
	~;
	if( $up > 2 ) {
		my %permselect = ( $UserPermissions{$ug} => ' selected' );
		print qq~<tr><td>User Permissions:</td><td><select name="permissions"><option value="1"$permselect{'1'}>Standard (can post, build and edit own posts)</option><option value="2"$permselect{'2'}>High (same as Standard, but can edit/remove all posts)</option><option value="3"$permselect{'3'}>Webmaster (full administrative access; cannot be removed)</option></select></td></tr>~;
	}
}

sub NoriegaUGSave {
	my @nui = qw/pword email permissions/;
	foreach (@nui) {
		$in{$_} =~ s/\n//g;
		$in{$_} =~ s/\r//g;
		$in{$_} =~ s/\|/(pipe)/g;
		$in{$_} =~ s/``x/` ` x/g;
		$in{$_} =~ s/~/(tilde)/g;
	}
	if ($in{'pword'}) {
		$CPassword{$ug} = crypt ($in{'pword'}, join '', ('.', '/', 0..9, 'A'..'Z', 'a'..'z')[rand 64, rand 64]);
	}
	$Email{$ug} = $in{'email'};
	if($in{'permissions'} && $up > 2) {
		$UserPermissions{$ug} = $in{'permissions'};
	}
	&FormatUserInfo;
	&WriteConfigInfo;
	return undef;
}

sub Noriega_HTMLFoot {
	my($pwidth,$pheight) = split( /~/, $NPConfig{'npopupopt'} );
	$pwidth ||= 600;
	$pheight ||= 400;
	print qq~ <a class="navlink" href="$scripturl?noriega" onclick="NewWindow(this.href,'name','$pwidth','$pheight','yes');return false;">Noriega</a> |~;
}

sub Noriega_PageHandler {
	if( $qstring eq 'noriega' || $qstring eq 'noriega/help' || $qstring eq 'noriega/colors' ) {
		if( $in{'clearcolors'} ) { delete $NPConfig{'npopupopt'};&WriteConfigInfo; }
		my( $rowbgo, $rowtxto, $bodytxto, $nmessage );
		my @whole = split( /~/, $NPConfig{'npopupopt'} );
		my $pwidth = $whole[0] || 600;
		my $pheight = $whole[1] || 400;
		my $bodybg = $whole[2] || q~#000000~;
		my @bodytxt = split(/[^#\w]+/,$whole[3]);
		my @rowbgs = split(/[^#\w]+/,$whole[4]);
		my @rowtxts = split(/[^#\w]+/,$whole[5]);
		unless( @rowbgs ) { @rowbgs = qw/#FFAA00 #5555BB/; }
		unless( @rowtxts ) { @rowtxts = qw/#0000FF #FFAA00/; }
		unless( @bodytxt ) { @bodytxt = qw/#008800 #FF0000 #FF0000 #FF00FF/; }

		if( $in{'savecolors'} ) {
			foreach (keys %in) {
				$in{$_} =~ s/\n//g;
				$in{$_} =~ s/\r//g;
				$in{$_} =~ s/\|//g;
				$in{$_} =~ s/``x/` ` x/g;
				$in{$_} =~ s/~//g;
			}
			$pwidth = $in{'pwidth'} || $pwidth;
			$pheight = $in{'pheight'} || $pheight;
			$bodybg = $in{'bodybg'} || $bodybg;
			$bodytxt[0] = $in{'text'} || $bodytxt[0];
			$bodytxt[1] = $in{'link'} || $bodytxt[1];
			$bodytxt[2] = $in{'vlink'} || $bodytxt[2];
			$bodytxt[3] = $in{'alink'} || $bodytxt[3];
			$rowbgo = join( ',', split(/[^#\w]+/,$in{'rowbgs'}) );
			$rowtxto = join( ',', split(/[^#\w]+/,$in{'rowtxts'}) );
			$bodytxto = join( ',', @bodytxt );
			$NPConfig{'npopupopt'} = join( '~', ( $pwidth, $pheight, $bodybg, $bodytxto, $rowbgo, $rowtxto ) );
			&WriteConfigInfo;
			$nmessage = q~ (( settings saved))~;
		}
		elsif( $in{'clearcolors'} ) { $nmessage = q~ ((defaults saved))~; }

		print qq~<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><title>Manuel Noriega</title></head><body bgcolor="$bodybg" text="$bodytxt[0]" link="$bodytxt[1]" vlink="$bodytxt[2]" alink="$bodytxt[3]" leftmargin="0" topmargin="0" marginwidth="0" marginheight="0"><table align="center" width="100%" border="0" cellpadding="5" cellspacing="2">~;
		if( $qstring eq 'noriega/help' ) {
			print q~<tr><td><HR color="$bodytxt[0]">Clicking on the Noriega link at the bottom of a NewsPro page brings up this tiny window which shows all users and their email addresses.<BR><BR>Noriega also integrates (loosely) with UserGroups, so that webmasters may change the password, email address, or userlevel of any user.<BR><BR>Please note that even though these three properties <i>appear</i> to be part of UserGroups, they are <i><b>not managed or stored by UserGroups</b></i>. Noriega simply uses UserGroups as a convenient and familiar interface.<BR><BR>
Noriega Colors: You may use color names or hex values: &quot;red&quot; <i>or</i> &quot;#FF0000&quot; ... The two bottom fields allow you to choose several colors to cycle between when drawing the rows of users. The colors you type in should be separated by commas or spaces, although you may use any character which is not a letter, number, underscore, or the pound # sign.<BR><HR color="$bodytxt[0]"><BR>
<a target="hypecolor" href="http://www.users.interport.net/%7Egiant/COLOR/1ColorSpecifier.html">Hype's Color Specifier</a> : Find the hex values of some nice web-safe colors.</td></tr>
~;
		}
		elsif( $qstring eq 'noriega/colors' ) {
			print qq~<tr><td colspan="3" align="center">noriega popup settings$nmessage<HR color="$bodytxt[0]"></td></tr>~;
			$rowbgo = join(' ', @rowbgs);
			$rowtxto = join(' ', @rowtxts);
			print qq~<form action="$scripturl?noriega/colors" method="post"><tr><td>
<input type="text" name="pwidth" size="3" value="$pwidth"> width<BR></td><td>
<input type="text" name="pheight" size="3" value="$pheight"> height<BR></td></tr><tr><td>
<input type="text" name="bodybg" size="8" value="$bodybg"> bgcolor<BR></td><td>
<input type="text" name="text" size="8" value="$bodytxt[0]"> text<BR></td></tr><tr><td>
<input type="text" name="link" size="8" value="$bodytxt[1]"> link<BR></td><td>
<input type="text" name="vlink" size="8" value="$bodytxt[2]"> vlink<BR></td><td>
<input type="text" name="alink" size="8" value="$bodytxt[3]"> alink<BR></td></tr><tr><td colspan="9">
<HR color="$bodytxt[0]"><div align="center">row background colors<BR>
<input type="text" name="rowbgs" size="30" style="width: 100%" value="$rowbgo"><BR>
row text colors:<BR>
<input type="text" name="rowtxts" size="30" style="width: 100%" value="$rowtxto"></div><BR>
<div align="right"><input type="submit" name="clearcolors" value="Defaults">
&nbsp;<input type="reset" name="resetcolors" value="Reset">&nbsp;
<input type="submit" name="savecolors" value="Apply"></div></td></tr>
</form>~;
		}
		else {
			my $rowcount = 0;
			foreach (@usernames) {
				my $rowbg = $rowbgs[($rowcount % @rowbgs)];
				my $rowtxt = $rowtxts[($rowcount % @rowtxts)];
				print qq~<tr><td width="10" bgcolor="$rowbg"><font color="$rowtxt">$UserPermissions{$_}</font>&nbsp;</td><td width="40%" bgcolor="$rowbg"><a href="mailto:$Email{$_}"><font color="$rowtxt">$_</font></a>&nbsp;</td><td width="60%" bgcolor="$rowbg"><font color="$rowtxt">$Email{$_}</font>&nbsp;</td></tr>~;
				$rowcount++;
			}
		}
		print qq~</table><br><center>| <a href="$scripturl?noriega">refresh</a> |~;
		if( $up > 2 ) {
			print qq~<a href="$scripturl?noriega/colors">colors</a> |~;
		}
		print qq~ <a href="$scripturl?noriega/help">help</a> | <a href="" onClick="window.close(); return false;">close</a> |</center></body></html>~;
		exit;
	}
}

sub Noriega_NPHTMLHead_Head {
print q~<script language="JavaScript">
<!--
function NewWindow(mypage, myname, w, h, scroll) {
var winw = (screen.width - w) / 2;
var winh = (screen.height - h) / 2;
winprops = 'height='+h+',width='+w+',top='+winh+',left='+winw+',scrollbars='+scroll+',resizable'
win = window.open(mypage, myname, winprops)
if (parseInt(navigator.appVersion) >= 4) { win.window.focus(); }
}
//-->
</script>~;
}
1;